<script setup lang="ts">
    import { ref, watch } from 'vue'
    import { Message } from '@/shared/administration/entities/messages/Message'
    import { MessageApi } from '@/shared/administration/entities/messages/MessageApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { useRouter } from 'vue-router'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import RouteNavigationDrawer from '@/shared/administration/components/RouteNavigationDrawer.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const messages = ref<Message[]>([])
    const messageApi = new MessageApi(msal)

    const router = useRouter()

    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            getAllMessages()
        },
        { immediate: true }
    )

    function getAllMessages() {
        isLoading.value = true
        messageApi
            .getAll()
            .then((returnedMessages) => (messages.value = returnedMessages))
            .finally(() => (isLoading.value = false))
    }

    function deleteMessage(id: number) {
        emitSnackBar(`Message supprimé`, 'primary')
        messageApi.delete(id)
        getAllMessages()
    }

    function removeAllTagsExceptb(body: string | undefined) {
        if (body) {
            return body.replace(/<(?!\/?b\b)[^>]*>/g, '')
        }
    }

    function redirectToEditPage(id: number) {
        router.push({
            name: 'admin/message/modifier',
            params: { id },
        })
    }
</script>

<template>
    <route-navigation-drawer page-title="Messages" />
    <v-main>
        <s-content-container>
            <h2 class="pt-3">{{ messages.length }} messages</h2>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading"
            ></v-skeleton-loader>
            <v-list>
                <v-list-item v-for="message in messages" :key="message.id">
                    <v-alert
                        :title="message.title"
                        :color="message.color"
                        data-cy="message"
                        style="cursor: pointer"
                        @click="redirectToEditPage(message.id)"
                    >
                        <template #close="{ props }">
                            <v-btn
                                v-bind="props"
                                color="background"
                                variant="flat"
                                @click.stop="deleteMessage(message.id)"
                            >
                                <v-icon
                                    color="error"
                                    data-cy="message-delete-btn"
                                    >mdi-trash-can-outline</v-icon
                                >
                            </v-btn>
                        </template>
                        <!-- eslint-disable vue/no-v-html -->
                        <div>
                            <p
                                style="white-space: pre-wrap"
                                v-html="removeAllTagsExceptb(message.body)"
                            ></p>
                            <div
                                style="
                                    border-top: 1px solid background;
                                    margin: 8px 0;
                                "
                            ></div>
                            <p>
                                Début:
                                {{
                                    message.startDate
                                        ? new Date(
                                              message.startDate
                                          ).toLocaleDateString('fr-FR')
                                        : 'non défini'
                                }}
                                - Fin:
                                {{
                                    message.endDate
                                        ? new Date(
                                              message.endDate
                                          ).toLocaleDateString('fr-FR')
                                        : 'non défini'
                                }}
                            </p>
                        </div>
                    </v-alert>
                </v-list-item>
            </v-list>
            <s-action-button
                icon="mdi-plus"
                label="Ajouter un message"
                data-cy="create-message-button"
                display="floating-fixed"
                position="right"
                :to="{
                    name: 'admin/message/créer',
                }"
            >
            </s-action-button>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
